<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>JRecord.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute.compiler</a> &gt; <span class="el_source">JRecord.java</span></div><h1>JRecord.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute.compiler;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

/**
 *
 */
public class JRecord extends JCompType {

    private String mFQName;
    private String mName;
    private String mModule;
    private ArrayList&lt;JField&gt; mFields;

    /**
     * Creates a new instance of JRecord
     */
    public JRecord(String name, ArrayList&lt;JField&gt; flist) {
<span class="nc" id="L42">        super(&quot;struct &quot; + name.substring(name.lastIndexOf('.')+1),</span>
<span class="nc" id="L43">                name.replaceAll(&quot;\\.&quot;,&quot;::&quot;), getCsharpFQName(name), name, &quot;Record&quot;, name, getCsharpFQName(&quot;IRecord&quot;));</span>
<span class="nc" id="L44">        mFQName = name;</span>
<span class="nc" id="L45">        int idx = name.lastIndexOf('.');</span>
<span class="nc" id="L46">        mName = name.substring(idx+1);</span>
<span class="nc" id="L47">        mModule = name.substring(0, idx);</span>
<span class="nc" id="L48">        mFields = flist;</span>
<span class="nc" id="L49">    }</span>

    public String getName() {
<span class="nc" id="L52">        return mName;</span>
    }

    public String getCsharpName() {
<span class="nc bnc" id="L56" title="All 2 branches missed.">        return &quot;Id&quot;.equals(mName) ? &quot;ZKId&quot; : mName;</span>
    }

    public String getJavaFQName() {
<span class="nc" id="L60">        return mFQName;</span>
    }

    public String getCppFQName() {
<span class="nc" id="L64">        return mFQName.replaceAll(&quot;\\.&quot;, &quot;::&quot;);</span>
    }

    public String getJavaPackage() {
<span class="nc" id="L68">        return mModule;</span>
    }

    public String getCppNameSpace() {
<span class="nc" id="L72">        return mModule.replaceAll(&quot;\\.&quot;, &quot;::&quot;);</span>
    }

    public String getCsharpNameSpace() {
<span class="nc" id="L76">        String[] parts = mModule.split(&quot;\\.&quot;);</span>
<span class="nc" id="L77">        StringBuffer namespace = new StringBuffer();</span>
<span class="nc bnc" id="L78" title="All 2 branches missed.">        for (int i = 0; i &lt; parts.length; i++) {</span>
<span class="nc" id="L79">            String capitalized = parts[i].substring(0, 1).toUpperCase() + parts[i].substring(1).toLowerCase();</span>
<span class="nc" id="L80">            namespace.append(capitalized);</span>
<span class="nc bnc" id="L81" title="All 2 branches missed.">            if (i != parts.length - 1) namespace.append(&quot;.&quot;);</span>
        }
<span class="nc" id="L83">        return namespace.toString();</span>
    }

    public ArrayList&lt;JField&gt; getFields() {
<span class="nc" id="L87">        return mFields;</span>
    }

    public String getSignature() {
<span class="nc" id="L91">        StringBuilder sb = new StringBuilder();</span>
<span class="nc" id="L92">        sb.append(&quot;L&quot;).append(mName).append(&quot;(&quot;);</span>
<span class="nc bnc" id="L93" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext();) {</span>
<span class="nc" id="L94">            String s = i.next().getSignature();</span>
<span class="nc" id="L95">            sb.append(s);</span>
<span class="nc" id="L96">        }</span>
<span class="nc" id="L97">        sb.append(&quot;)&quot;);</span>
<span class="nc" id="L98">        return sb.toString();</span>
    }

    public String genCppDecl(String fname) {
<span class="nc" id="L102">        return &quot;  &quot;+ getCppNameSpace() + &quot;::&quot; + mName+&quot; m&quot;+fname+&quot;;\n&quot;;</span>
    }

    public String genJavaReadMethod(String fname, String tag) {
<span class="nc" id="L106">        return genJavaReadWrapper(fname, tag, false);</span>
    }

    public String genJavaReadWrapper(String fname, String tag, boolean decl) {
<span class="nc" id="L110">        StringBuilder ret = new StringBuilder(&quot;&quot;);</span>
<span class="nc bnc" id="L111" title="All 2 branches missed.">        if (decl) {</span>
<span class="nc" id="L112">            ret.append(&quot;    &quot;+getJavaFQName()+&quot; &quot;+fname+&quot;;\n&quot;);</span>
        }
<span class="nc" id="L114">        ret.append(&quot;    &quot;+fname+&quot;= new &quot;+getJavaFQName()+&quot;();\n&quot;);</span>
<span class="nc" id="L115">        ret.append(&quot;    a_.readRecord(&quot;+fname+&quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L116">        return ret.toString();</span>
    }

    public String genJavaWriteWrapper(String fname, String tag) {
<span class="nc" id="L120">        return &quot;    a_.writeRecord(&quot;+fname+&quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;;</span>
    }

    String genCsharpReadMethod(String fname, String tag) {
        //return &quot;    &quot;+capitalize(fname)+&quot;=a_.Read&quot;+mMethodSuffix+&quot;(&quot; + capitalize(fname) + &quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;;
<span class="nc" id="L125">        return genCsharpReadWrapper(capitalize(fname), tag, false);</span>
    }

    public String genCsharpReadWrapper(String fname, String tag, boolean decl) {
<span class="nc" id="L129">        StringBuilder ret = new StringBuilder(&quot;&quot;);</span>
<span class="nc bnc" id="L130" title="All 2 branches missed.">        if (decl) {</span>
<span class="nc" id="L131">            ret.append(&quot;    &quot;+getCsharpFQName(mFQName)+&quot; &quot;+fname+&quot;;\n&quot;);</span>
        }
<span class="nc" id="L133">        ret.append(&quot;    &quot;+fname+&quot;= new &quot;+getCsharpFQName(mFQName)+&quot;();\n&quot;);</span>
<span class="nc" id="L134">        ret.append(&quot;    a_.ReadRecord(&quot;+fname+&quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L135">        return ret.toString();</span>
    }

    public String genCsharpWriteWrapper(String fname, String tag) {
<span class="nc" id="L139">        return &quot;    a_.WriteRecord(&quot;+fname+&quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;;</span>
    }

<span class="nc" id="L142">    static HashMap&lt;String, String&gt; vectorStructs = new HashMap&lt;String, String&gt;();</span>
    public void genCCode(FileWriter h, FileWriter c) throws IOException {
<span class="nc bnc" id="L144" title="All 2 branches missed.">        for (JField f : mFields) {</span>
<span class="nc bnc" id="L145" title="All 2 branches missed.">            if (f.getType() instanceof JVector) {</span>
<span class="nc" id="L146">                JVector jv = (JVector)f.getType();</span>
<span class="nc" id="L147">                JType jvType = jv.getElementType();</span>
<span class="nc" id="L148">                String struct_name = JVector.extractVectorName(jvType);</span>
<span class="nc bnc" id="L149" title="All 2 branches missed.">                if (vectorStructs.get(struct_name) == null) {</span>
<span class="nc" id="L150">                    vectorStructs.put(struct_name, struct_name);</span>
<span class="nc" id="L151">                    h.write(&quot;struct &quot; + struct_name + &quot; {\n    int32_t count;\n&quot; + jv.getElementType().genCDecl(&quot;*data&quot;) + &quot;\n};\n&quot;);</span>
<span class="nc" id="L152">                    h.write(&quot;int serialize_&quot; + struct_name + &quot;(struct oarchive *out, const char *tag, struct &quot; + struct_name + &quot; *v);\n&quot;);</span>
<span class="nc" id="L153">                    h.write(&quot;int deserialize_&quot; + struct_name + &quot;(struct iarchive *in, const char *tag, struct &quot; + struct_name + &quot; *v);\n&quot;);</span>
<span class="nc" id="L154">                    h.write(&quot;int allocate_&quot; + struct_name + &quot;(struct &quot; + struct_name + &quot; *v, int32_t len);\n&quot;);</span>
<span class="nc" id="L155">                    h.write(&quot;int deallocate_&quot; + struct_name + &quot;(struct &quot; + struct_name + &quot; *v);\n&quot;);</span>
<span class="nc" id="L156">                    c.write(&quot;int allocate_&quot; + struct_name + &quot;(struct &quot; + struct_name + &quot; *v, int32_t len) {\n&quot;);</span>
<span class="nc" id="L157">                    c.write(&quot;    if (!len) {\n&quot;);</span>
<span class="nc" id="L158">                    c.write(&quot;        v-&gt;count = 0;\n&quot;);</span>
<span class="nc" id="L159">                    c.write(&quot;        v-&gt;data = 0;\n&quot;);</span>
<span class="nc" id="L160">                    c.write(&quot;    } else {\n&quot;);</span>
<span class="nc" id="L161">                    c.write(&quot;        v-&gt;count = len;\n&quot;);</span>
<span class="nc" id="L162">                    c.write(&quot;        v-&gt;data = calloc(sizeof(*v-&gt;data), len);\n&quot;);</span>
<span class="nc" id="L163">                    c.write(&quot;    }\n&quot;);</span>
<span class="nc" id="L164">                    c.write(&quot;    return 0;\n&quot;);</span>
<span class="nc" id="L165">                    c.write(&quot;}\n&quot;);</span>
<span class="nc" id="L166">                    c.write(&quot;int deallocate_&quot; + struct_name + &quot;(struct &quot; + struct_name + &quot; *v) {\n&quot;);</span>
<span class="nc" id="L167">                    c.write(&quot;    if (v-&gt;data) {\n&quot;);</span>
<span class="nc" id="L168">                    c.write(&quot;        int32_t i;\n&quot;);</span>
<span class="nc" id="L169">                    c.write(&quot;        for(i=0;i&lt;v-&gt;count; i++) {\n&quot;);</span>
<span class="nc" id="L170">                    c.write(&quot;            deallocate_&quot;+JRecord.extractMethodSuffix(jvType)+&quot;(&amp;v-&gt;data[i]);\n&quot;);</span>
<span class="nc" id="L171">                    c.write(&quot;        }\n&quot;);</span>
<span class="nc" id="L172">                    c.write(&quot;        free(v-&gt;data);\n&quot;);</span>
<span class="nc" id="L173">                    c.write(&quot;        v-&gt;data = 0;\n&quot;);</span>
<span class="nc" id="L174">                    c.write(&quot;    }\n&quot;);</span>
<span class="nc" id="L175">                    c.write(&quot;    return 0;\n&quot;);</span>
<span class="nc" id="L176">                    c.write(&quot;}\n&quot;);</span>
<span class="nc" id="L177">                    c.write(&quot;int serialize_&quot; + struct_name + &quot;(struct oarchive *out, const char *tag, struct &quot; + struct_name + &quot; *v)\n&quot;);</span>
<span class="nc" id="L178">                    c.write(&quot;{\n&quot;);</span>
<span class="nc" id="L179">                    c.write(&quot;    int32_t count = v-&gt;count;\n&quot;);</span>
<span class="nc" id="L180">                    c.write(&quot;    int rc = 0;\n&quot;);</span>
<span class="nc" id="L181">                    c.write(&quot;    int32_t i;\n&quot;);</span>
<span class="nc" id="L182">                    c.write(&quot;    rc = out-&gt;start_vector(out, tag, &amp;count);\n&quot;);</span>
<span class="nc" id="L183">                    c.write(&quot;    for(i=0;i&lt;v-&gt;count;i++) {\n&quot;);</span>
<span class="nc" id="L184">                    genSerialize(c, jvType, &quot;data&quot;, &quot;data[i]&quot;);</span>
<span class="nc" id="L185">                    c.write(&quot;    }\n&quot;);</span>
<span class="nc" id="L186">                    c.write(&quot;    rc = rc ? rc : out-&gt;end_vector(out, tag);\n&quot;);</span>
<span class="nc" id="L187">                    c.write(&quot;    return rc;\n&quot;);</span>
<span class="nc" id="L188">                    c.write(&quot;}\n&quot;);</span>
<span class="nc" id="L189">                    c.write(&quot;int deserialize_&quot; + struct_name + &quot;(struct iarchive *in, const char *tag, struct &quot; + struct_name + &quot; *v)\n&quot;);</span>
<span class="nc" id="L190">                    c.write(&quot;{\n&quot;);</span>
<span class="nc" id="L191">                    c.write(&quot;    int rc = 0;\n&quot;);</span>
<span class="nc" id="L192">                    c.write(&quot;    int32_t i;\n&quot;);</span>
<span class="nc" id="L193">                    c.write(&quot;    rc = in-&gt;start_vector(in, tag, &amp;v-&gt;count);\n&quot;);</span>
<span class="nc" id="L194">                    c.write(&quot;    v-&gt;data = calloc(v-&gt;count, sizeof(*v-&gt;data));\n&quot;);</span>
<span class="nc" id="L195">                    c.write(&quot;    for(i=0;i&lt;v-&gt;count;i++) {\n&quot;);</span>
<span class="nc" id="L196">                    genDeserialize(c, jvType, &quot;value&quot;, &quot;data[i]&quot;);</span>
<span class="nc" id="L197">                    c.write(&quot;    }\n&quot;);</span>
<span class="nc" id="L198">                    c.write(&quot;    rc = in-&gt;end_vector(in, tag);\n&quot;);</span>
<span class="nc" id="L199">                    c.write(&quot;    return rc;\n&quot;);</span>
<span class="nc" id="L200">                    c.write(&quot;}\n&quot;);</span>

                }
            }
<span class="nc" id="L204">        }</span>
<span class="nc" id="L205">        String rec_name = getName();</span>
<span class="nc" id="L206">        h.write(&quot;struct &quot; + rec_name + &quot; {\n&quot;);</span>
<span class="nc bnc" id="L207" title="All 2 branches missed.">        for (JField f : mFields) {</span>
<span class="nc" id="L208">            h.write(f.genCDecl());</span>
<span class="nc" id="L209">        }</span>
<span class="nc" id="L210">        h.write(&quot;};\n&quot;);</span>
<span class="nc" id="L211">        h.write(&quot;int serialize_&quot; + rec_name + &quot;(struct oarchive *out, const char *tag, struct &quot; + rec_name + &quot; *v);\n&quot;);</span>
<span class="nc" id="L212">        h.write(&quot;int deserialize_&quot; + rec_name + &quot;(struct iarchive *in, const char *tag, struct &quot; + rec_name + &quot;*v);\n&quot;);</span>
<span class="nc" id="L213">        h.write(&quot;void deallocate_&quot; + rec_name + &quot;(struct &quot; + rec_name + &quot;*);\n&quot;);</span>
<span class="nc" id="L214">        c.write(&quot;int serialize_&quot; + rec_name + &quot;(struct oarchive *out, const char *tag, struct &quot; + rec_name + &quot; *v)&quot;);</span>
<span class="nc" id="L215">        c.write(&quot;{\n&quot;);</span>
<span class="nc" id="L216">        c.write(&quot;    int rc;\n&quot;);</span>
<span class="nc" id="L217">        c.write(&quot;    rc = out-&gt;start_record(out, tag);\n&quot;);</span>
<span class="nc bnc" id="L218" title="All 2 branches missed.">        for(JField f : mFields) {</span>
<span class="nc" id="L219">            genSerialize(c, f.getType(), f.getTag(), f.getName());</span>
<span class="nc" id="L220">        }</span>
<span class="nc" id="L221">        c.write(&quot;    rc = rc ? rc : out-&gt;end_record(out, tag);\n&quot;);</span>
<span class="nc" id="L222">        c.write(&quot;    return rc;\n&quot;);</span>
<span class="nc" id="L223">        c.write(&quot;}\n&quot;);</span>
<span class="nc" id="L224">        c.write(&quot;int deserialize_&quot; + rec_name + &quot;(struct iarchive *in, const char *tag, struct &quot; + rec_name + &quot;*v)&quot;);</span>
<span class="nc" id="L225">        c.write(&quot;{\n&quot;);</span>
<span class="nc" id="L226">        c.write(&quot;    int rc;\n&quot;);</span>
<span class="nc" id="L227">        c.write(&quot;    rc = in-&gt;start_record(in, tag);\n&quot;);</span>
<span class="nc bnc" id="L228" title="All 2 branches missed.">        for(JField f : mFields) {</span>
<span class="nc" id="L229">            genDeserialize(c, f.getType(), f.getTag(), f.getName());</span>
<span class="nc" id="L230">        }</span>
<span class="nc" id="L231">        c.write(&quot;    rc = rc ? rc : in-&gt;end_record(in, tag);\n&quot;);</span>
<span class="nc" id="L232">        c.write(&quot;    return rc;\n&quot;);</span>
<span class="nc" id="L233">        c.write(&quot;}\n&quot;);</span>
<span class="nc" id="L234">        c.write(&quot;void deallocate_&quot; + rec_name + &quot;(struct &quot; + rec_name + &quot;*v)&quot;);</span>
<span class="nc" id="L235">        c.write(&quot;{\n&quot;);</span>
<span class="nc bnc" id="L236" title="All 2 branches missed.">        for(JField f : mFields) {</span>
<span class="nc bnc" id="L237" title="All 2 branches missed.">            if (f.getType() instanceof JRecord) {</span>
<span class="nc" id="L238">                c.write(&quot;    deallocate_&quot; + extractStructName(f.getType()) + &quot;(&amp;v-&gt;&quot; + f.getName() + &quot;);\n&quot;);</span>
<span class="nc bnc" id="L239" title="All 2 branches missed.">            } else if (f.getType() instanceof JVector) {</span>
<span class="nc" id="L240">                JVector vt = (JVector)f.getType();</span>
<span class="nc" id="L241">                c.write(&quot;    deallocate_&quot; + JVector.extractVectorName(vt.getElementType())+ &quot;(&amp;v-&gt;&quot;+f.getName()+&quot;);\n&quot;);</span>
<span class="nc bnc" id="L242" title="All 2 branches missed.">            } else if (f.getType() instanceof JCompType) {</span>
<span class="nc" id="L243">                c.write(&quot;    deallocate_&quot; + extractMethodSuffix(f.getType()) + &quot;(&amp;v-&gt;&quot;+f.getName()+&quot;);\n&quot;);</span>
            }
<span class="nc" id="L245">        }</span>
<span class="nc" id="L246">        c.write(&quot;}\n&quot;);</span>
<span class="nc" id="L247">    }</span>

    private void genSerialize(FileWriter c, JType type, String tag, String name) throws IOException {
<span class="nc bnc" id="L250" title="All 2 branches missed.">        if (type instanceof JRecord) {</span>
<span class="nc" id="L251">            c.write(&quot;    rc = rc ? rc : serialize_&quot; + extractStructName(type) + &quot;(out, \&quot;&quot; + tag + &quot;\&quot;, &amp;v-&gt;&quot; + name + &quot;);\n&quot;);</span>
<span class="nc bnc" id="L252" title="All 2 branches missed.">        } else if (type instanceof JVector) {</span>
<span class="nc" id="L253">            c.write(&quot;    rc = rc ? rc : serialize_&quot; + JVector.extractVectorName(((JVector)type).getElementType()) + &quot;(out, \&quot;&quot; + tag + &quot;\&quot;, &amp;v-&gt;&quot; + name + &quot;);\n&quot;);</span>
        } else {
<span class="nc" id="L255">            c.write(&quot;    rc = rc ? rc : out-&gt;serialize_&quot; + extractMethodSuffix(type) + &quot;(out, \&quot;&quot; + tag + &quot;\&quot;, &amp;v-&gt;&quot; + name + &quot;);\n&quot;);</span>
        }
<span class="nc" id="L257">    }</span>

    private void genDeserialize(FileWriter c, JType type, String tag, String name) throws IOException {
<span class="nc bnc" id="L260" title="All 2 branches missed.">        if (type instanceof JRecord) {</span>
<span class="nc" id="L261">            c.write(&quot;    rc = rc ? rc : deserialize_&quot; + extractStructName(type) + &quot;(in, \&quot;&quot; + tag + &quot;\&quot;, &amp;v-&gt;&quot; + name + &quot;);\n&quot;);</span>
<span class="nc bnc" id="L262" title="All 2 branches missed.">        } else if (type instanceof JVector) {</span>
<span class="nc" id="L263">            c.write(&quot;    rc = rc ? rc : deserialize_&quot; + JVector.extractVectorName(((JVector)type).getElementType()) + &quot;(in, \&quot;&quot; + tag + &quot;\&quot;, &amp;v-&gt;&quot; + name + &quot;);\n&quot;);</span>
        } else {
<span class="nc" id="L265">            c.write(&quot;    rc = rc ? rc : in-&gt;deserialize_&quot; + extractMethodSuffix(type) + &quot;(in, \&quot;&quot; + tag + &quot;\&quot;, &amp;v-&gt;&quot; + name + &quot;);\n&quot;);</span>
        }
<span class="nc" id="L267">    }</span>

    static String extractMethodSuffix(JType t) {
<span class="nc bnc" id="L270" title="All 2 branches missed.">        if (t instanceof JRecord) {</span>
<span class="nc" id="L271">            return extractStructName(t);</span>
        }
<span class="nc" id="L273">        return t.getMethodSuffix();</span>
    }

    static private String extractStructName(JType t) {
<span class="nc" id="L277">        String type = t.getCType();</span>
<span class="nc bnc" id="L278" title="All 2 branches missed.">        if (!type.startsWith(&quot;struct &quot;)) return type;</span>
<span class="nc" id="L279">        return type.substring(&quot;struct &quot;.length());</span>
    }

    public void genCppCode(FileWriter hh, FileWriter cc)
        throws IOException {
<span class="nc" id="L284">        String[] ns = getCppNameSpace().split(&quot;::&quot;);</span>
<span class="nc bnc" id="L285" title="All 2 branches missed.">        for (int i = 0; i &lt; ns.length; i++) {</span>
<span class="nc" id="L286">            hh.write(&quot;namespace &quot;+ns[i]+&quot; {\n&quot;);</span>
        }

<span class="nc" id="L289">        hh.write(&quot;class &quot;+getName()+&quot; : public ::hadoop::Record {\n&quot;);</span>
<span class="nc" id="L290">        hh.write(&quot;private:\n&quot;);</span>

<span class="nc bnc" id="L292" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext();) {</span>
<span class="nc" id="L293">            JField jf = i.next();</span>
<span class="nc" id="L294">            hh.write(jf.genCppDecl());</span>
<span class="nc" id="L295">        }</span>
<span class="nc" id="L296">        hh.write(&quot;  mutable std::bitset&lt;&quot;+mFields.size()+&quot;&gt; bs_;\n&quot;);</span>
<span class="nc" id="L297">        hh.write(&quot;public:\n&quot;);</span>
<span class="nc" id="L298">        hh.write(&quot;  virtual void serialize(::hadoop::OArchive&amp; a_, const char* tag) const;\n&quot;);</span>
<span class="nc" id="L299">        hh.write(&quot;  virtual void deserialize(::hadoop::IArchive&amp; a_, const char* tag);\n&quot;);</span>
<span class="nc" id="L300">        hh.write(&quot;  virtual const ::std::string&amp; type() const;\n&quot;);</span>
<span class="nc" id="L301">        hh.write(&quot;  virtual const ::std::string&amp; signature() const;\n&quot;);</span>
<span class="nc" id="L302">        hh.write(&quot;  virtual bool validate() const;\n&quot;);</span>
<span class="nc" id="L303">        hh.write(&quot;  virtual bool operator&lt;(const &quot;+getName()+&quot;&amp; peer_) const;\n&quot;);</span>
<span class="nc" id="L304">        hh.write(&quot;  virtual bool operator==(const &quot;+getName()+&quot;&amp; peer_) const;\n&quot;);</span>
<span class="nc" id="L305">        hh.write(&quot;  virtual ~&quot;+getName()+&quot;() {};\n&quot;);</span>
<span class="nc" id="L306">        int fIdx = 0;</span>
<span class="nc bnc" id="L307" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L308">            JField jf = i.next();</span>
<span class="nc" id="L309">            hh.write(jf.genCppGetSet(fIdx));</span>
        }
<span class="nc" id="L311">        hh.write(&quot;}; // end record &quot;+getName()+&quot;\n&quot;);</span>
<span class="nc bnc" id="L312" title="All 2 branches missed.">        for (int i=ns.length-1; i&gt;=0; i--) {</span>
<span class="nc" id="L313">            hh.write(&quot;} // end namespace &quot;+ns[i]+&quot;\n&quot;);</span>
        }
<span class="nc" id="L315">        cc.write(&quot;void &quot;+getCppFQName()+&quot;::serialize(::hadoop::OArchive&amp; a_, const char* tag) const {\n&quot;);</span>
<span class="nc" id="L316">        cc.write(&quot;  if (!validate()) throw new ::hadoop::IOException(\&quot;All fields not set.\&quot;);\n&quot;);</span>
<span class="nc" id="L317">        cc.write(&quot;  a_.startRecord(*this,tag);\n&quot;);</span>
<span class="nc" id="L318">        fIdx = 0;</span>
<span class="nc bnc" id="L319" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L320">            JField jf = i.next();</span>
<span class="nc" id="L321">            String name = jf.getName();</span>
<span class="nc bnc" id="L322" title="All 2 branches missed.">            if (jf.getType() instanceof JBuffer) {</span>
<span class="nc" id="L323">                cc.write(&quot;  a_.serialize(m&quot;+name+&quot;,m&quot;+name+&quot;.length(),\&quot;&quot;+jf.getTag()+&quot;\&quot;);\n&quot;);</span>
            } else {
<span class="nc" id="L325">                cc.write(&quot;  a_.serialize(m&quot;+name+&quot;,\&quot;&quot;+jf.getTag()+&quot;\&quot;);\n&quot;);</span>
            }
<span class="nc" id="L327">            cc.write(&quot;  bs_.reset(&quot;+fIdx+&quot;);\n&quot;);</span>
        }
<span class="nc" id="L329">        cc.write(&quot;  a_.endRecord(*this,tag);\n&quot;);</span>
<span class="nc" id="L330">        cc.write(&quot;  return;\n&quot;);</span>
<span class="nc" id="L331">        cc.write(&quot;}\n&quot;);</span>

<span class="nc" id="L333">        cc.write(&quot;void &quot;+getCppFQName()+&quot;::deserialize(::hadoop::IArchive&amp; a_, const char* tag) {\n&quot;);</span>
<span class="nc" id="L334">        cc.write(&quot;  a_.startRecord(*this,tag);\n&quot;);</span>
<span class="nc" id="L335">        fIdx = 0;</span>
<span class="nc bnc" id="L336" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L337">            JField jf = i.next();</span>
<span class="nc" id="L338">            String name = jf.getName();</span>
<span class="nc bnc" id="L339" title="All 2 branches missed.">            if (jf.getType() instanceof JBuffer) {</span>
<span class="nc" id="L340">                cc.write(&quot;  { size_t len=0; a_.deserialize(m&quot;+name+&quot;,len,\&quot;&quot;+jf.getTag()+&quot;\&quot;);}\n&quot;);</span>
            } else {
<span class="nc" id="L342">                cc.write(&quot;  a_.deserialize(m&quot;+name+&quot;,\&quot;&quot;+jf.getTag()+&quot;\&quot;);\n&quot;);</span>
            }
<span class="nc" id="L344">            cc.write(&quot;  bs_.set(&quot;+fIdx+&quot;);\n&quot;);</span>
        }
<span class="nc" id="L346">        cc.write(&quot;  a_.endRecord(*this,tag);\n&quot;);</span>
<span class="nc" id="L347">        cc.write(&quot;  return;\n&quot;);</span>
<span class="nc" id="L348">        cc.write(&quot;}\n&quot;);</span>

<span class="nc" id="L350">        cc.write(&quot;bool &quot;+getCppFQName()+&quot;::validate() const {\n&quot;);</span>
<span class="nc" id="L351">        cc.write(&quot;  if (bs_.size() != bs_.count()) return false;\n&quot;);</span>
<span class="nc bnc" id="L352" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L353">            JField jf = (JField) i.next();</span>
<span class="nc" id="L354">            JType type = jf.getType();</span>
<span class="nc bnc" id="L355" title="All 2 branches missed.">            if (type instanceof JRecord) {</span>
<span class="nc" id="L356">                cc.write(&quot;  if (!m&quot;+jf.getName()+&quot;.validate()) return false;\n&quot;);</span>
            }
        }
<span class="nc" id="L359">        cc.write(&quot;  return true;\n&quot;);</span>
<span class="nc" id="L360">        cc.write(&quot;}\n&quot;);</span>

<span class="nc" id="L362">        cc.write(&quot;bool &quot;+getCppFQName()+&quot;::operator&lt; (const &quot;+getCppFQName()+&quot;&amp; peer_) const {\n&quot;);</span>
<span class="nc" id="L363">        cc.write(&quot;  return (1\n&quot;);</span>
<span class="nc bnc" id="L364" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext();) {</span>
<span class="nc" id="L365">            JField jf = i.next();</span>
<span class="nc" id="L366">            String name = jf.getName();</span>
<span class="nc" id="L367">            cc.write(&quot;    &amp;&amp; (m&quot;+name+&quot; &lt; peer_.m&quot;+name+&quot;)\n&quot;);</span>
<span class="nc" id="L368">        }</span>
<span class="nc" id="L369">        cc.write(&quot;  );\n&quot;);</span>
<span class="nc" id="L370">        cc.write(&quot;}\n&quot;);</span>

<span class="nc" id="L372">        cc.write(&quot;bool &quot;+getCppFQName()+&quot;::operator== (const &quot;+getCppFQName()+&quot;&amp; peer_) const {\n&quot;);</span>
<span class="nc" id="L373">        cc.write(&quot;  return (1\n&quot;);</span>
<span class="nc bnc" id="L374" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext();) {</span>
<span class="nc" id="L375">            JField jf = i.next();</span>
<span class="nc" id="L376">            String name = jf.getName();</span>
<span class="nc" id="L377">            cc.write(&quot;    &amp;&amp; (m&quot;+name+&quot; == peer_.m&quot;+name+&quot;)\n&quot;);</span>
<span class="nc" id="L378">        }</span>
<span class="nc" id="L379">        cc.write(&quot;  );\n&quot;);</span>
<span class="nc" id="L380">        cc.write(&quot;}\n&quot;);</span>

<span class="nc" id="L382">        cc.write(&quot;const ::std::string&amp;&quot;+getCppFQName()+&quot;::type() const {\n&quot;);</span>
<span class="nc" id="L383">        cc.write(&quot;  static const ::std::string type_(\&quot;&quot;+mName+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L384">        cc.write(&quot;  return type_;\n&quot;);</span>
<span class="nc" id="L385">        cc.write(&quot;}\n&quot;);</span>

<span class="nc" id="L387">        cc.write(&quot;const ::std::string&amp;&quot;+getCppFQName()+&quot;::signature() const {\n&quot;);</span>
<span class="nc" id="L388">        cc.write(&quot;  static const ::std::string sig_(\&quot;&quot;+getSignature()+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L389">        cc.write(&quot;  return sig_;\n&quot;);</span>
<span class="nc" id="L390">        cc.write(&quot;}\n&quot;);</span>

<span class="nc" id="L392">    }</span>

    public void genJavaCode(File outputDirectory) throws IOException {
<span class="nc" id="L395">        String pkg = getJavaPackage();</span>
<span class="nc" id="L396">        String pkgpath = pkg.replaceAll(&quot;\\.&quot;, &quot;/&quot;);</span>
<span class="nc" id="L397">        File pkgdir = new File(outputDirectory, pkgpath);</span>
<span class="nc bnc" id="L398" title="All 2 branches missed.">        if (!pkgdir.exists()) {</span>
            // create the pkg directory
<span class="nc bnc" id="L400" title="All 2 branches missed.">            if (!pkgdir.mkdirs()) {</span>
<span class="nc" id="L401">                throw new IOException(&quot;Cannnot create directory: &quot; + pkgpath);</span>
            }
<span class="nc bnc" id="L403" title="All 2 branches missed.">        } else if (!pkgdir.isDirectory()) {</span>
<span class="nc" id="L404">            throw new IOException(pkgpath + &quot; is not a directory.&quot;);</span>
        }
<span class="nc" id="L406">        File jfile = new File(pkgdir, getName()+&quot;.java&quot;);</span>
<span class="nc" id="L407">        FileWriter jj = new FileWriter(jfile);</span>
<span class="nc" id="L408">        jj.write(&quot;// File generated by hadoop record compiler. Do not edit.\n&quot;);</span>
<span class="nc" id="L409">        jj.write(&quot;/**\n&quot;);</span>
<span class="nc" id="L410">        jj.write(&quot;* Licensed to the Apache Software Foundation (ASF) under one\n&quot;);</span>
<span class="nc" id="L411">        jj.write(&quot;* or more contributor license agreements.  See the NOTICE file\n&quot;);</span>
<span class="nc" id="L412">        jj.write(&quot;* distributed with this work for additional information\n&quot;);</span>
<span class="nc" id="L413">        jj.write(&quot;* regarding copyright ownership.  The ASF licenses this file\n&quot;);</span>
<span class="nc" id="L414">        jj.write(&quot;* to you under the Apache License, Version 2.0 (the\n&quot;);</span>
<span class="nc" id="L415">        jj.write(&quot;* \&quot;License\&quot;); you may not use this file except in compliance\n&quot;);</span>
<span class="nc" id="L416">        jj.write(&quot;* with the License.  You may obtain a copy of the License at\n&quot;);</span>
<span class="nc" id="L417">        jj.write(&quot;*\n&quot;);</span>
<span class="nc" id="L418">        jj.write(&quot;*     http://www.apache.org/licenses/LICENSE-2.0\n&quot;);</span>
<span class="nc" id="L419">        jj.write(&quot;*\n&quot;);</span>
<span class="nc" id="L420">        jj.write(&quot;* Unless required by applicable law or agreed to in writing, software\n&quot;);</span>
<span class="nc" id="L421">        jj.write(&quot;* distributed under the License is distributed on an \&quot;AS IS\&quot; BASIS,\n&quot;);</span>
<span class="nc" id="L422">        jj.write(&quot;* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n&quot;);</span>
<span class="nc" id="L423">        jj.write(&quot;* See the License for the specific language governing permissions and\n&quot;);</span>
<span class="nc" id="L424">        jj.write(&quot;* limitations under the License.\n&quot;);</span>
<span class="nc" id="L425">        jj.write(&quot;*/\n&quot;);</span>
<span class="nc" id="L426">        jj.write(&quot;\n&quot;);</span>
<span class="nc" id="L427">        jj.write(&quot;package &quot;+getJavaPackage()+&quot;;\n\n&quot;);</span>
<span class="nc" id="L428">        jj.write(&quot;import org.apache.jute.*;\n&quot;);</span>
<span class="nc" id="L429">        jj.write(&quot;public class &quot;+getName()+&quot; implements Record {\n&quot;);</span>
<span class="nc bnc" id="L430" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext();) {</span>
<span class="nc" id="L431">            JField jf = i.next();</span>
<span class="nc" id="L432">            jj.write(jf.genJavaDecl());</span>
<span class="nc" id="L433">        }</span>
<span class="nc" id="L434">        jj.write(&quot;  public &quot;+getName()+&quot;() {\n&quot;);</span>
<span class="nc" id="L435">        jj.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L437">        jj.write(&quot;  public &quot;+getName()+&quot;(\n&quot;);</span>
<span class="nc" id="L438">        int fIdx = 0;</span>
<span class="nc" id="L439">        int fLen = mFields.size();</span>
<span class="nc bnc" id="L440" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L441">            JField jf = i.next();</span>
<span class="nc" id="L442">            jj.write(jf.genJavaConstructorParam(jf.getName()));</span>
<span class="nc bnc" id="L443" title="All 2 branches missed.">            jj.write((fLen-1 == fIdx)?&quot;&quot;:&quot;,\n&quot;);</span>
        }
<span class="nc" id="L445">        jj.write(&quot;) {\n&quot;);</span>
<span class="nc" id="L446">        fIdx = 0;</span>
<span class="nc bnc" id="L447" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L448">            JField jf = i.next();</span>
<span class="nc" id="L449">            jj.write(jf.genJavaConstructorSet(jf.getName()));</span>
        }
<span class="nc" id="L451">        jj.write(&quot;  }\n&quot;);</span>
<span class="nc" id="L452">        fIdx = 0;</span>
<span class="nc bnc" id="L453" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L454">            JField jf = i.next();</span>
<span class="nc" id="L455">            jj.write(jf.genJavaGetSet(fIdx));</span>
        }
<span class="nc" id="L457">        jj.write(&quot;  public void serialize(OutputArchive a_, String tag) throws java.io.IOException {\n&quot;);</span>
<span class="nc" id="L458">        jj.write(&quot;    a_.startRecord(this,tag);\n&quot;);</span>
<span class="nc" id="L459">        fIdx = 0;</span>
<span class="nc bnc" id="L460" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L461">            JField jf = i.next();</span>
<span class="nc" id="L462">            jj.write(jf.genJavaWriteMethodName());</span>
        }
<span class="nc" id="L464">        jj.write(&quot;    a_.endRecord(this,tag);\n&quot;);</span>
<span class="nc" id="L465">        jj.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L467">        jj.write(&quot;  public void deserialize(InputArchive a_, String tag) throws java.io.IOException {\n&quot;);</span>
<span class="nc" id="L468">        jj.write(&quot;    a_.startRecord(tag);\n&quot;);</span>
<span class="nc" id="L469">        fIdx = 0;</span>
<span class="nc bnc" id="L470" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L471">            JField jf = i.next();</span>
<span class="nc" id="L472">            jj.write(jf.genJavaReadMethodName());</span>
        }
<span class="nc" id="L474">        jj.write(&quot;    a_.endRecord(tag);\n&quot;);</span>
<span class="nc" id="L475">        jj.write(&quot;}\n&quot;);</span>

<span class="nc" id="L477">        jj.write(&quot;  public String toString() {\n&quot;);</span>
<span class="nc" id="L478">        jj.write(&quot;    try {\n&quot;);</span>
<span class="nc" id="L479">        jj.write(&quot;      java.io.ByteArrayOutputStream s =\n&quot;);</span>
<span class="nc" id="L480">        jj.write(&quot;        new java.io.ByteArrayOutputStream();\n&quot;);</span>
<span class="nc" id="L481">        jj.write(&quot;      CsvOutputArchive a_ = \n&quot;);</span>
<span class="nc" id="L482">        jj.write(&quot;        new CsvOutputArchive(s);\n&quot;);</span>
<span class="nc" id="L483">        jj.write(&quot;      a_.startRecord(this,\&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L484">        fIdx = 0;</span>
<span class="nc bnc" id="L485" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L486">            JField jf = i.next();</span>
<span class="nc" id="L487">            jj.write(jf.genJavaWriteMethodName());</span>
        }
<span class="nc" id="L489">        jj.write(&quot;      a_.endRecord(this,\&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L490">        jj.write(&quot;      return new String(s.toByteArray(), \&quot;UTF-8\&quot;);\n&quot;);</span>
<span class="nc" id="L491">        jj.write(&quot;    } catch (Throwable ex) {\n&quot;);</span>
<span class="nc" id="L492">        jj.write(&quot;      ex.printStackTrace();\n&quot;);</span>
<span class="nc" id="L493">        jj.write(&quot;    }\n&quot;);</span>
<span class="nc" id="L494">        jj.write(&quot;    return \&quot;ERROR\&quot;;\n&quot;);</span>
<span class="nc" id="L495">        jj.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L497">        jj.write(&quot;  public void write(java.io.DataOutput out) throws java.io.IOException {\n&quot;);</span>
<span class="nc" id="L498">        jj.write(&quot;    BinaryOutputArchive archive = new BinaryOutputArchive(out);\n&quot;);</span>
<span class="nc" id="L499">        jj.write(&quot;    serialize(archive, \&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L500">        jj.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L502">        jj.write(&quot;  public void readFields(java.io.DataInput in) throws java.io.IOException {\n&quot;);</span>
<span class="nc" id="L503">        jj.write(&quot;    BinaryInputArchive archive = new BinaryInputArchive(in);\n&quot;);</span>
<span class="nc" id="L504">        jj.write(&quot;    deserialize(archive, \&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L505">        jj.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L507">        jj.write(&quot;  public int compareTo (Object peer_) throws ClassCastException {\n&quot;);</span>
<span class="nc" id="L508">        boolean unimplemented = false;</span>
<span class="nc bnc" id="L509" title="All 2 branches missed.">        for (JField f : mFields) {</span>
<span class="nc bnc" id="L510" title="All 2 branches missed.">            if ((f.getType() instanceof JMap)</span>
<span class="nc bnc" id="L511" title="All 2 branches missed.">                    || (f.getType() instanceof JVector))</span>
            {
<span class="nc" id="L513">                unimplemented = true;</span>
            }
<span class="nc" id="L515">        }</span>
<span class="nc bnc" id="L516" title="All 2 branches missed.">        if (unimplemented) {</span>
<span class="nc" id="L517">            jj.write(&quot;    throw new UnsupportedOperationException(\&quot;comparing &quot;</span>
<span class="nc" id="L518">                    + getName() + &quot; is unimplemented\&quot;);\n&quot;);</span>
        } else {
<span class="nc" id="L520">            jj.write(&quot;    if (!(peer_ instanceof &quot;+getName()+&quot;)) {\n&quot;);</span>
<span class="nc" id="L521">            jj.write(&quot;      throw new ClassCastException(\&quot;Comparing different types of records.\&quot;);\n&quot;);</span>
<span class="nc" id="L522">            jj.write(&quot;    }\n&quot;);</span>
<span class="nc" id="L523">            jj.write(&quot;    &quot;+getName()+&quot; peer = (&quot;+getName()+&quot;) peer_;\n&quot;);</span>
<span class="nc" id="L524">            jj.write(&quot;    int ret = 0;\n&quot;);</span>
<span class="nc bnc" id="L525" title="All 2 branches missed.">            for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L526">                JField jf = i.next();</span>
<span class="nc" id="L527">                jj.write(jf.genJavaCompareTo());</span>
<span class="nc" id="L528">                jj.write(&quot;    if (ret != 0) return ret;\n&quot;);</span>
            }
<span class="nc" id="L530">            jj.write(&quot;     return ret;\n&quot;);</span>
        }
<span class="nc" id="L532">        jj.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L534">        jj.write(&quot;  public boolean equals(Object peer_) {\n&quot;);</span>
<span class="nc" id="L535">        jj.write(&quot;    if (!(peer_ instanceof &quot;+getName()+&quot;)) {\n&quot;);</span>
<span class="nc" id="L536">        jj.write(&quot;      return false;\n&quot;);</span>
<span class="nc" id="L537">        jj.write(&quot;    }\n&quot;);</span>
<span class="nc" id="L538">        jj.write(&quot;    if (peer_ == this) {\n&quot;);</span>
<span class="nc" id="L539">        jj.write(&quot;      return true;\n&quot;);</span>
<span class="nc" id="L540">        jj.write(&quot;    }\n&quot;);</span>
<span class="nc" id="L541">        jj.write(&quot;    &quot;+getName()+&quot; peer = (&quot;+getName()+&quot;) peer_;\n&quot;);</span>
<span class="nc" id="L542">        jj.write(&quot;    boolean ret = false;\n&quot;);</span>
<span class="nc bnc" id="L543" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L544">            JField jf = i.next();</span>
<span class="nc" id="L545">            jj.write(jf.genJavaEquals());</span>
<span class="nc" id="L546">            jj.write(&quot;    if (!ret) return ret;\n&quot;);</span>
        }
<span class="nc" id="L548">        jj.write(&quot;     return ret;\n&quot;);</span>
<span class="nc" id="L549">        jj.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L551">        jj.write(&quot;  public int hashCode() {\n&quot;);</span>
<span class="nc" id="L552">        jj.write(&quot;    int result = 17;\n&quot;);</span>
<span class="nc" id="L553">        jj.write(&quot;    int ret;\n&quot;);</span>
<span class="nc bnc" id="L554" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L555">            JField jf = i.next();</span>
<span class="nc" id="L556">            jj.write(jf.genJavaHashCode());</span>
<span class="nc" id="L557">            jj.write(&quot;    result = 37*result + ret;\n&quot;);</span>
        }
<span class="nc" id="L559">        jj.write(&quot;    return result;\n&quot;);</span>
<span class="nc" id="L560">        jj.write(&quot;  }\n&quot;);</span>
<span class="nc" id="L561">        jj.write(&quot;  public static String signature() {\n&quot;);</span>
<span class="nc" id="L562">        jj.write(&quot;    return \&quot;&quot;+getSignature()+&quot;\&quot;;\n&quot;);</span>
<span class="nc" id="L563">        jj.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L565">        jj.write(&quot;}\n&quot;);</span>

<span class="nc" id="L567">        jj.close();</span>
<span class="nc" id="L568">    }</span>

    public void genCsharpCode(File outputDirectory) throws IOException {
<span class="nc bnc" id="L571" title="All 2 branches missed.">        if (!outputDirectory.exists()) {</span>
            // create the pkg directory
<span class="nc bnc" id="L573" title="All 2 branches missed.">            if (!outputDirectory.mkdirs()) {</span>
<span class="nc" id="L574">                throw new IOException(&quot;Cannnot create directory: &quot; + outputDirectory);</span>
            }
<span class="nc bnc" id="L576" title="All 2 branches missed.">        } else if (!outputDirectory.isDirectory()) {</span>
<span class="nc" id="L577">            throw new IOException(outputDirectory + &quot; is not a directory.&quot;);</span>
        }
<span class="nc" id="L579">        File csharpFile = new File(outputDirectory, getName()+&quot;.cs&quot;);</span>
<span class="nc" id="L580">        FileWriter cs = new FileWriter(csharpFile);</span>
<span class="nc" id="L581">        cs.write(&quot;// File generated by hadoop record compiler. Do not edit.\n&quot;);</span>
<span class="nc" id="L582">        cs.write(&quot;/**\n&quot;);</span>
<span class="nc" id="L583">        cs.write(&quot;* Licensed to the Apache Software Foundation (ASF) under one\n&quot;);</span>
<span class="nc" id="L584">        cs.write(&quot;* or more contributor license agreements.  See the NOTICE file\n&quot;);</span>
<span class="nc" id="L585">        cs.write(&quot;* distributed with this work for additional information\n&quot;);</span>
<span class="nc" id="L586">        cs.write(&quot;* regarding copyright ownership.  The ASF licenses this file\n&quot;);</span>
<span class="nc" id="L587">        cs.write(&quot;* to you under the Apache License, Version 2.0 (the\n&quot;);</span>
<span class="nc" id="L588">        cs.write(&quot;* \&quot;License\&quot;); you may not use this file except in compliance\n&quot;);</span>
<span class="nc" id="L589">        cs.write(&quot;* with the License.  You may obtain a copy of the License at\n&quot;);</span>
<span class="nc" id="L590">        cs.write(&quot;*\n&quot;);</span>
<span class="nc" id="L591">        cs.write(&quot;*     http://www.apache.org/licenses/LICENSE-2.0\n&quot;);</span>
<span class="nc" id="L592">        cs.write(&quot;*\n&quot;);</span>
<span class="nc" id="L593">        cs.write(&quot;* Unless required by applicable law or agreed to in writing, software\n&quot;);</span>
<span class="nc" id="L594">        cs.write(&quot;* distributed under the License is distributed on an \&quot;AS IS\&quot; BASIS,\n&quot;);</span>
<span class="nc" id="L595">        cs.write(&quot;* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n&quot;);</span>
<span class="nc" id="L596">        cs.write(&quot;* See the License for the specific language governing permissions and\n&quot;);</span>
<span class="nc" id="L597">        cs.write(&quot;* limitations under the License.\n&quot;);</span>
<span class="nc" id="L598">        cs.write(&quot;*/\n&quot;);</span>
<span class="nc" id="L599">        cs.write(&quot;\n&quot;);</span>
<span class="nc" id="L600">        cs.write(&quot;using System;\n&quot;);</span>
<span class="nc" id="L601">        cs.write(&quot;using Org.Apache.Jute;\n&quot;);</span>
<span class="nc" id="L602">        cs.write(&quot;\n&quot;);        </span>
<span class="nc" id="L603">        cs.write(&quot;namespace &quot;+getCsharpNameSpace()+&quot;\n&quot;);</span>
<span class="nc" id="L604">        cs.write(&quot;{\n&quot;);</span>

<span class="nc" id="L606">        String className = getCsharpName();</span>
<span class="nc" id="L607">        cs.write(&quot;public class &quot;+className+&quot; : IRecord, IComparable \n&quot;);</span>
<span class="nc" id="L608">        cs.write(&quot;{\n&quot;);</span>
<span class="nc" id="L609">        cs.write(&quot;  public &quot;+ className +&quot;() {\n&quot;);</span>
<span class="nc" id="L610">        cs.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L612">        cs.write(&quot;  public &quot;+className+&quot;(\n&quot;);</span>
<span class="nc" id="L613">        int fIdx = 0;</span>
<span class="nc" id="L614">        int fLen = mFields.size();</span>
<span class="nc bnc" id="L615" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L616">            JField jf = i.next();</span>
<span class="nc" id="L617">            cs.write(jf.genCsharpConstructorParam(jf.getCsharpName()));</span>
<span class="nc bnc" id="L618" title="All 2 branches missed.">            cs.write((fLen-1 == fIdx)?&quot;&quot;:&quot;,\n&quot;);</span>
        }
<span class="nc" id="L620">        cs.write(&quot;) {\n&quot;);</span>
<span class="nc" id="L621">        fIdx = 0;</span>
<span class="nc bnc" id="L622" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L623">            JField jf = i.next();</span>
<span class="nc" id="L624">            cs.write(jf.genCsharpConstructorSet(jf.getCsharpName()));</span>
        }
<span class="nc" id="L626">        cs.write(&quot;  }\n&quot;);</span>
<span class="nc" id="L627">        fIdx = 0;</span>
<span class="nc bnc" id="L628" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L629">            JField jf = i.next();</span>
<span class="nc" id="L630">            cs.write(jf.genCsharpGetSet(fIdx));</span>
<span class="nc" id="L631">            cs.write(&quot;\n&quot;);</span>
        }
<span class="nc" id="L633">        cs.write(&quot;  public void Serialize(IOutputArchive a_, String tag) {\n&quot;);</span>
<span class="nc" id="L634">        cs.write(&quot;    a_.StartRecord(this,tag);\n&quot;);</span>
<span class="nc" id="L635">        fIdx = 0;</span>
<span class="nc bnc" id="L636" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L637">            JField jf = i.next();</span>
<span class="nc" id="L638">            cs.write(jf.genCsharpWriteMethodName());</span>
        }
<span class="nc" id="L640">        cs.write(&quot;    a_.EndRecord(this,tag);\n&quot;);</span>
<span class="nc" id="L641">        cs.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L643">        cs.write(&quot;  public void Deserialize(IInputArchive a_, String tag) {\n&quot;);</span>
<span class="nc" id="L644">        cs.write(&quot;    a_.StartRecord(tag);\n&quot;);</span>
<span class="nc" id="L645">        fIdx = 0;</span>
<span class="nc bnc" id="L646" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L647">            JField jf = i.next();</span>
<span class="nc" id="L648">            cs.write(jf.genCsharpReadMethodName());</span>
        }
<span class="nc" id="L650">        cs.write(&quot;    a_.EndRecord(tag);\n&quot;);</span>
<span class="nc" id="L651">        cs.write(&quot;}\n&quot;);</span>

<span class="nc" id="L653">        cs.write(&quot;  public override String ToString() {\n&quot;);</span>
<span class="nc" id="L654">        cs.write(&quot;    try {\n&quot;);</span>
<span class="nc" id="L655">        cs.write(&quot;      System.IO.MemoryStream ms = new System.IO.MemoryStream();\n&quot;);</span>
<span class="nc" id="L656">        cs.write(&quot;      MiscUtil.IO.EndianBinaryWriter writer =\n&quot;);</span>
<span class="nc" id="L657">        cs.write(&quot;        new MiscUtil.IO.EndianBinaryWriter(MiscUtil.Conversion.EndianBitConverter.Big, ms, System.Text.Encoding.UTF8);\n&quot;);</span>
<span class="nc" id="L658">        cs.write(&quot;      BinaryOutputArchive a_ = \n&quot;);</span>
<span class="nc" id="L659">        cs.write(&quot;        new BinaryOutputArchive(writer);\n&quot;);</span>
<span class="nc" id="L660">        cs.write(&quot;      a_.StartRecord(this,\&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L661">        fIdx = 0;</span>
<span class="nc bnc" id="L662" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L663">            JField jf = i.next();</span>
<span class="nc" id="L664">            cs.write(jf.genCsharpWriteMethodName());</span>
        }
<span class="nc" id="L666">        cs.write(&quot;      a_.EndRecord(this,\&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L667">        cs.write(&quot;      ms.Position = 0;\n&quot;);</span>
<span class="nc" id="L668">        cs.write(&quot;      return System.Text.Encoding.UTF8.GetString(ms.ToArray());\n&quot;);</span>
<span class="nc" id="L669">        cs.write(&quot;    } catch (Exception ex) {\n&quot;);</span>
<span class="nc" id="L670">        cs.write(&quot;      Console.WriteLine(ex.StackTrace);\n&quot;);</span>
<span class="nc" id="L671">        cs.write(&quot;    }\n&quot;);</span>
<span class="nc" id="L672">        cs.write(&quot;    return \&quot;ERROR\&quot;;\n&quot;);</span>
<span class="nc" id="L673">        cs.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L675">        cs.write(&quot;  public void Write(MiscUtil.IO.EndianBinaryWriter writer) {\n&quot;);</span>
<span class="nc" id="L676">        cs.write(&quot;    BinaryOutputArchive archive = new BinaryOutputArchive(writer);\n&quot;);</span>
<span class="nc" id="L677">        cs.write(&quot;    Serialize(archive, \&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L678">        cs.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L680">        cs.write(&quot;  public void ReadFields(MiscUtil.IO.EndianBinaryReader reader) {\n&quot;);</span>
<span class="nc" id="L681">        cs.write(&quot;    BinaryInputArchive archive = new BinaryInputArchive(reader);\n&quot;);</span>
<span class="nc" id="L682">        cs.write(&quot;    Deserialize(archive, \&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L683">        cs.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L685">        cs.write(&quot;  public int CompareTo (object peer_) {\n&quot;);</span>
<span class="nc" id="L686">        boolean unimplemented = false;</span>
<span class="nc bnc" id="L687" title="All 2 branches missed.">        for (JField f : mFields) {</span>
<span class="nc bnc" id="L688" title="All 2 branches missed.">            if ((f.getType() instanceof JMap)</span>
<span class="nc bnc" id="L689" title="All 2 branches missed.">                    || (f.getType() instanceof JVector))</span>
            {
<span class="nc" id="L691">                unimplemented = true;</span>
            }
<span class="nc" id="L693">        }</span>
<span class="nc bnc" id="L694" title="All 2 branches missed.">        if (unimplemented) {</span>
<span class="nc" id="L695">            cs.write(&quot;    throw new InvalidOperationException(\&quot;comparing &quot;</span>
<span class="nc" id="L696">                    + getCsharpName() + &quot; is unimplemented\&quot;);\n&quot;);</span>
        } else {
<span class="nc" id="L698">            cs.write(&quot;    if (!(peer_ is &quot;+getCsharpName()+&quot;)) {\n&quot;);</span>
<span class="nc" id="L699">            cs.write(&quot;      throw new InvalidOperationException(\&quot;Comparing different types of records.\&quot;);\n&quot;);</span>
<span class="nc" id="L700">            cs.write(&quot;    }\n&quot;);</span>
<span class="nc" id="L701">            cs.write(&quot;    &quot;+getCsharpName()+&quot; peer = (&quot;+getCsharpName()+&quot;) peer_;\n&quot;);</span>
<span class="nc" id="L702">            cs.write(&quot;    int ret = 0;\n&quot;);</span>
<span class="nc bnc" id="L703" title="All 2 branches missed.">            for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L704">                JField jf = i.next();</span>
<span class="nc" id="L705">                cs.write(jf.genCsharpCompareTo());</span>
<span class="nc" id="L706">                cs.write(&quot;    if (ret != 0) return ret;\n&quot;);</span>
            }
<span class="nc" id="L708">            cs.write(&quot;     return ret;\n&quot;);</span>
        }
<span class="nc" id="L710">        cs.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L712">        cs.write(&quot;  public override bool Equals(object peer_) {\n&quot;);</span>
<span class="nc" id="L713">        cs.write(&quot;    if (!(peer_ is &quot;+getCsharpName()+&quot;)) {\n&quot;);</span>
<span class="nc" id="L714">        cs.write(&quot;      return false;\n&quot;);</span>
<span class="nc" id="L715">        cs.write(&quot;    }\n&quot;);</span>
<span class="nc" id="L716">        cs.write(&quot;    if (peer_ == this) {\n&quot;);</span>
<span class="nc" id="L717">        cs.write(&quot;      return true;\n&quot;);</span>
<span class="nc" id="L718">        cs.write(&quot;    }\n&quot;);</span>
<span class="nc" id="L719">        cs.write(&quot;    bool ret = false;\n&quot;);</span>
<span class="nc" id="L720">        cs.write(&quot;    &quot; + getCsharpName() + &quot; peer = (&quot; + getCsharpName() + &quot;)peer_;\n&quot;);</span>
<span class="nc bnc" id="L721" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L722">            JField jf = i.next();</span>
<span class="nc" id="L723">            cs.write(jf.genCsharpEquals());</span>
<span class="nc" id="L724">            cs.write(&quot;    if (!ret) return ret;\n&quot;);</span>
        }
<span class="nc" id="L726">        cs.write(&quot;     return ret;\n&quot;);</span>
<span class="nc" id="L727">        cs.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L729">        cs.write(&quot;  public override int GetHashCode() {\n&quot;);</span>
<span class="nc" id="L730">        cs.write(&quot;    int result = 17;\n&quot;);</span>
<span class="nc" id="L731">        cs.write(&quot;    int ret;\n&quot;);</span>
<span class="nc bnc" id="L732" title="All 2 branches missed.">        for (Iterator&lt;JField&gt; i = mFields.iterator(); i.hasNext(); fIdx++) {</span>
<span class="nc" id="L733">            JField jf = i.next();</span>
<span class="nc" id="L734">            cs.write(jf.genCsharpHashCode());</span>
<span class="nc" id="L735">            cs.write(&quot;    result = 37*result + ret;\n&quot;);</span>
        }
<span class="nc" id="L737">        cs.write(&quot;    return result;\n&quot;);</span>
<span class="nc" id="L738">        cs.write(&quot;  }\n&quot;);</span>
<span class="nc" id="L739">        cs.write(&quot;  public static string Signature() {\n&quot;);</span>
<span class="nc" id="L740">        cs.write(&quot;    return \&quot;&quot;+getSignature()+&quot;\&quot;;\n&quot;);</span>
<span class="nc" id="L741">        cs.write(&quot;  }\n&quot;);</span>

<span class="nc" id="L743">        cs.write(&quot;}\n&quot;);</span>
<span class="nc" id="L744">        cs.write(&quot;}\n&quot;);</span>

<span class="nc" id="L746">        cs.close();</span>
<span class="nc" id="L747">    }</span>

    public static String getCsharpFQName(String name) {
<span class="nc" id="L750">        String[] packages = name.split(&quot;\\.&quot;);</span>
<span class="nc" id="L751">        StringBuffer fQName = new StringBuffer();</span>
<span class="nc bnc" id="L752" title="All 2 branches missed.">        for (int i = 0; i &lt; packages.length; i++) {</span>
<span class="nc" id="L753">            String pack = packages[i];</span>
<span class="nc" id="L754">            pack = capitalize(pack);</span>
<span class="nc bnc" id="L755" title="All 2 branches missed.">            pack = &quot;Id&quot;.equals(pack) ? &quot;ZKId&quot; : pack;</span>
<span class="nc" id="L756">            fQName.append(capitalize(pack));</span>
<span class="nc bnc" id="L757" title="All 2 branches missed.">            if (i != packages.length - 1) fQName.append(&quot;.&quot;);</span>
        }
<span class="nc" id="L759">        return fQName.toString();</span>
    }    
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>